// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from micro_ros_diagnostic_msgs:srv/MicroROSSelfTest.idl
// generated code does not contain a copyright notice
#include "micro_ros_diagnostic_msgs/srv/detail/micro_ros_self_test__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__init(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__fini(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request *
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request * msg = (micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request *)allocator.allocate(sizeof(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request));
  bool success = micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__destroy(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__Sequence__init(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request * data = NULL;

  if (size) {
    data = (micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request *)allocator.zero_allocate(size, sizeof(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__Sequence__fini(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__Sequence *
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__Sequence * array = (micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__Sequence *)allocator.allocate(sizeof(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__Sequence__destroy(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}


// Include directives for member types
// Member `id`
#include "rosidl_runtime_c/string_functions.h"
// Member `status`
#include "micro_ros_diagnostic_msgs/msg/detail/micro_ros_diagnostic_status__functions.h"

bool
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__init(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response * msg)
{
  if (!msg) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__init(&msg->id)) {
    micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__fini(msg);
    return false;
  }
  // passed
  // status
  if (!micro_ros_diagnostic_msgs__msg__MicroROSDiagnosticStatus__init(&msg->status)) {
    micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__fini(msg);
    return false;
  }
  return true;
}

void
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__fini(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response * msg)
{
  if (!msg) {
    return;
  }
  // id
  rosidl_runtime_c__String__fini(&msg->id);
  // passed
  // status
  micro_ros_diagnostic_msgs__msg__MicroROSDiagnosticStatus__fini(&msg->status);
}

micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response *
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response * msg = (micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response *)allocator.allocate(sizeof(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response));
  bool success = micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__destroy(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__Sequence__init(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response * data = NULL;

  if (size) {
    data = (micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response *)allocator.zero_allocate(size, sizeof(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__Sequence__fini(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__Sequence *
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__Sequence * array = (micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__Sequence *)allocator.allocate(sizeof(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__Sequence__destroy(micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    micro_ros_diagnostic_msgs__srv__MicroROSSelfTest_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}
